#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

struct vertex
{
    vector<int> next;
};

void dfs(vector<vertex>& G, vector<bool> used, vector<bool>& ans, int v, int len)
{
    used[v] = 1;
    ans[v] = 1;

    if (len <= 0)
        return;

    for (int i = 0; i < G[v].next.size(); i++)
    {
        if (!used[G[v].next[i]])
        {
            dfs(G, used, ans, G[v].next[i], len - 1);
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int n, m, k;
    cin >> n >> m >> k;

    vector<vertex> G(n);
    for (int i = 0; i < m; i++)
    {
        int a, b;
        cin >> a >> b;

        a--; b--;

        G[a].next.push_back(b);
        G[b].next.push_back(a);
    }

    vector<bool> ans(n);
    for (int i = 0; i < k; i++)
    {
        int p, h;
        cin >> p >> h;

        p--;

        dfs(G, vector<bool>(n, 0), ans, p, h);
    }

    int c = 0;
    string ans_str = "";

    for (int i = 0; i < n; i++)
    {
        if (ans[i])
        {
            c++;
            ans_str += to_string(i + 1) + " ";
        }
    }

    cout << c << endl << ans_str;

    return 0;
}
